﻿<template>
    <Card class="member-form-card">
        <MemberForm @formSubmit="handleSubmit" />
        <p>{{ t('pages.createAccount.avatarText') }} <a href="https://avatarmaker.com/" target="_blank">{{ t('pages.createAccount.avatarLink') }}</a></p>
    </Card>
</template>

<script lang="ts" setup>
    import MemberForm from "@/components/members/MemberForm.vue"
    import Card from "@/components/layout/Card.vue";
    import {useI18n} from "vue3-i18n";
    import {Member} from "@/types/entities";
    import {notifyError, notifySuccess} from "@/notify";
    import {useMemberService} from "@/inversify.config";
    import { ICreateMemberRequest } from "@/types/requests/createMemberRequest";

    const {t} = useI18n()
    const memberService = useMemberService();

    async function handleSubmit(member: Member) {
        let succeededOrNotResponse = await memberService.createMember(member as ICreateMemberRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.member.add.success'))
            setTimeout(() => {
                location.replace('/Authentication/Login/')
            }, 1500);
        } else {
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.member.add');
            if (errorMessages.length == 0)
                notifyError(t('validation.member.add.errorOccured'))
            else
                notifyError(errorMessages[0])
        }
    }
</script>

<style>
    .member-form-card {
        margin: 20px;
    }

    .member-form-card p {
        margin-top: 10px;
    }
</style>